
void set_maxlines_maxcols(int y,int x) {
  MAX_LINES=y-3;   MAX_COLS=x-2; 
  leftmar=0; rightmar=x-3; topmar=0;
}
void short_cuts() {
	wmove(win,topmar,leftmar);
	WINDOW *temp;
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(6,40,maxy/2-3,maxx/2-20);
	outer=newwin(8,42,maxy/2-4,maxx/2-21);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0); 
	wrefresh(outer);
	mvwprintw(temp,0,3," <Ctrl>+l :Delete the current line ");
	mvwprintw(temp,1,3," <Ctrl>+w :Delete the current word ");
	mvwprintw(temp,2,3," <Ctrl>+n :Delete up to the end    ");
	mvwprintw(temp,3,3," <Ctrl>+c :yanking for cut         ");
	mvwprintw(temp,4,3," <Ctrl>+s :yanking for paste       ");
	mvwprintw(temp,5,3," <Ctrl>+p :paste yanked lines      ");
	
	wrefresh(temp);
	chtype c; c=wgetch(temp);
}

void yank_help() {
	wmove(win,topmar,leftmar);
	WINDOW *temp;
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(4,52,maxy/2-2,maxx/2-26);
	outer=newwin(6,54,maxy/2-3,maxx/2-27);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0); 
	wrefresh(outer);
      mvwprintw(temp,0,1,"ESE nDD(cut): Cuts n lines from the current line");
      mvwprintw(temp,1,1,"ESE nYY(sel): Selects n lines from the current line");
      mvwprintw(temp,2,1,"ESE P(paste): Pastes n selected lines below the   ");
      mvwprintw(temp,3,1,"              current line                        ");
	wrefresh(temp);
	chtype c; c=wgetch(temp);
}
	
	
void draw()
{
	init_pair(4,COLOR_GREEN,COLOR_BLUE);
	top=newwin(1,maxx,0,0);
	menu=newwin(1,maxx-2,1,1);
        left=newwin(maxy-1,1,1,0);
        right=newwin(maxy-1,1,1,maxx-1);
	bottom=newwin(1,maxx-2,maxy-1,1);
	for (int i=1; i<maxy-2; i++) {
		wmove(left,i,0);
		if (i%2==1) waddch(left,'/');
		 else waddch(left,'\\');
	}
	for (int i=1; i<maxy-2; i++) {
		wmove(right,i,0);
		if (i%2==1) waddch(right,'\\');
		 else waddch(right,'/');
	}
        wbkgd(top,COLOR_PAIR(1)|A_BOLD);
	wbkgd(menu,COLOR_PAIR(3)|A_BOLD);
	wbkgd(left,COLOR_PAIR(1));
	wbkgd(right,COLOR_PAIR(1));
	wbkgd(bottom,COLOR_PAIR(1));
	wmove(menu,0,2);
	waddstr(menu,"ile");
	wmove(menu,0,12);
	waddstr(menu,"dit");
	wmove(menu,0,23);
	waddstr(menu,"ank_it");
	wmove(menu,0,34);
	waddstr(menu,"ptions");
	wmove(menu,0,44);
	waddstr(menu,"se");
	wmove(menu,0,47);
	waddstr(menu,"rch");
	wmove(menu,0,56);
	waddstr(menu,"elp");
	wcolor_set(menu,4,0);
	mvwaddstr(menu,0,1,"F");
	mvwaddstr(menu,0,11,"E");
	mvwaddstr(menu,0,22,"Y");
	mvwaddstr(menu,0,33,"O");
	mvwaddstr(menu,0,46,"A");
	mvwaddstr(menu,0,55,"H");
        mvwprintw(bottom,0,2," Menu selection: <Ctrl> [feyoah]      ");
        mvwprintw(bottom,0,maxx-30," INS Line:1 Col:%d ",leftmar+1);
	mvwprintw(top,0,2,"Anj edit");
wrefresh(top);wrefresh(menu); wrefresh(bottom); 
	wrefresh(right); wrefresh(left);
}

int showmenu(char **menuitems,int n,int menu_num,int &c)
{   
  chtype ch= 'f';  int i=1;
  short select=1;
  WINDOW *temp; WINDOW *outer;
  PANEL *ptemp;
   temp=newwin(n,14,3,(((menu_num-1)*11+2)));
   outer=newwin(n+2,16,2,(((menu_num-1)*11+1)));
   
   ptemp=new_panel(temp);
   top_panel(ptemp);
   doupdate();
   wattron(temp,COLOR_PAIR(1));
   wattron(temp,A_BOLD);  
   wattron(outer,COLOR_PAIR(3));
   wattron(temp,A_BOLD);
   box(outer,0,0);
   wbkgd(outer,COLOR_PAIR(3));
   wrefresh(outer);
   keypad(temp,TRUE);
  curs_set(0);
   wbkgd(temp,COLOR_PAIR(1));
   for(i=1;i<= n;i++)    {
     if(i==1)
       wattrset(temp,A_REVERSE|A_BOLD);
        mvwaddstr(temp,i-1,0,menuitems[i-1]);
        wattroff(temp,A_REVERSE|A_BOLD);
     	}

      do   
         {
          for(i=1;i<= n;i++)   
          {
           if(i==select)
             wattrset(temp,A_REVERSE|A_BOLD);
           mvwaddstr(temp,i-1,0,menuitems[i-1]);
           wattroff(temp,A_REVERSE|A_BOLD);
          }
           flushinp();
           ch=wgetch(temp);
           switch(ch)  
          {
		  case 27 :            top_panel(pan);
			     doupdate();
			        curs_set(1);
                                 return -1;
                       	             break;
              case KEY_UP     :
                                if(select==1) select= n;
                                else select--;    break;
              case KEY_DOWN   :
		       	        if(select==n) select= 1;
                               else select++;    break;
	      case KEY_RIGHT : 
			       if (menu_num==1) c=5;
			       if (menu_num==3) c=15;
			       if (menu_num==4) c=1;
			       if (menu_num==5) c=8;
			       if (menu_num==2) c=25;
			       if (menu_num==6) c=6;
			       top_panel(pan); 
                               wrefresh(win);   
			       doupdate(); 
			       curs_set(1);
			       return 0; break;
	      case KEY_LEFT : 
			       if (menu_num==1) c=8;
			       if (menu_num==3) c=5;
			       if (menu_num==4) c=25;
			       if (menu_num==5) c=15;
			       if (menu_num==6) c=1;
			       if (menu_num==2) c=6;
			      top_panel(pan);
			      wrefresh(win);
			      doupdate(); curs_set(1);
			      return 0; break;
	      case 5: 
	      case 6:
	      case 25:
	      case 15:
	      case 8:
	      case 1:
			       c=ch; top_panel(pan);
			       wrefresh(win);
			       doupdate();return 0;
			       break;
			      
             case 10 : top_panel(pan);wrefresh(win);
		       curs_set(1);
	                return select;
			break;
             default :
			        beep();   
			break;
	
            }
          }while(ch!=27);
 curs_set(1);
 }
int color=0;
void change_color()
{  color++;//    1==top,bot,right,left.  2=menu and 6=current line
	if(color==16){
	        init_pair(1,COLOR_RED,COLOR_BLACK);
		init_pair(2,COLOR_BLUE,COLOR_BLACK);
		init_pair(6,COLOR_WHITE,COLOR_BLACK);
	}
	if(color==16)
		color=0;
	if(color==1){
		init_pair(1,COLOR_GREEN,COLOR_RED);
		init_pair(2,COLOR_RED,COLOR_BLACK);
		init_pair(6,COLOR_WHITE,COLOR_BLACK);
	}
	if(color==2){
		init_pair(1,COLOR_RED,COLOR_YELLOW);
		init_pair(2,COLOR_WHITE,COLOR_BLACK);
		init_pair(6,COLOR_BLUE,COLOR_BLACK);
	}
	if(color==3){
		init_pair(1,COLOR_RED,COLOR_GREEN);
		init_pair(2,COLOR_WHITE,COLOR_BLACK);
		init_pair(6,COLOR_RED,COLOR_BLACK);
	}
	if(color==4){
		init_pair(1,COLOR_RED,COLOR_BLACK);
		init_pair(2,COLOR_GREEN,COLOR_WHITE);
		init_pair(6,COLOR_BLUE,COLOR_WHITE);
	}
	if(color==5){
		init_pair(1,COLOR_RED,COLOR_GREEN);
		init_pair(2,COLOR_RED,COLOR_WHITE);
		init_pair(6,COLOR_BLUE,COLOR_WHITE);
	}
	if(color==6){
		init_pair(1,COLOR_GREEN,COLOR_RED);
		init_pair(2,COLOR_RED,COLOR_WHITE);
		init_pair(6,COLOR_BLUE,COLOR_WHITE);
	}
	if(color==7){
		init_pair(1,COLOR_RED,COLOR_BLACK);
		init_pair(2,COLOR_GREEN,COLOR_RED);
		init_pair(6,COLOR_BLUE,COLOR_RED);
	}
	if(color==8){
		init_pair(1,COLOR_RED,COLOR_GREEN);
		init_pair(2,COLOR_BLACK,COLOR_RED);
		init_pair(6,COLOR_WHITE,COLOR_RED);
	}
	if(color==9){
		init_pair(1,COLOR_RED,COLOR_WHITE);
		init_pair(2,COLOR_WHITE,COLOR_RED);
		init_pair(6,COLOR_GREEN,COLOR_RED);
	}
	if(color==10){
		init_pair(1,COLOR_RED,COLOR_BLACK);
		init_pair(2,COLOR_RED,COLOR_GREEN);
		init_pair(6,COLOR_WHITE,COLOR_GREEN);
	}
	if(color==11){
		init_pair(1,COLOR_YELLOW,COLOR_RED);
		init_pair(2,COLOR_BLACK,COLOR_GREEN);
		init_pair(6,COLOR_WHITE,COLOR_GREEN);
	}
	if(color==12){
		init_pair(1,COLOR_RED,COLOR_WHITE);
		init_pair(2,COLOR_WHITE,COLOR_GREEN);
		init_pair(6,COLOR_RED,COLOR_GREEN);
	}
	if(color==13){
		init_pair(1,COLOR_RED,COLOR_BLACK);
		init_pair(2,COLOR_RED,COLOR_YELLOW);
		init_pair(6,COLOR_GREEN,COLOR_YELLOW);
	}
	if(color==14){
		init_pair(1,COLOR_GREEN,COLOR_RED);
		init_pair(2,COLOR_BLACK,COLOR_YELLOW);
		init_pair(6,COLOR_RED,COLOR_YELLOW);
	}
	if(color==15){
		init_pair(1,COLOR_RED,COLOR_GREEN);
		init_pair(2,COLOR_GREEN,COLOR_YELLOW);
		init_pair(6,COLOR_RED,COLOR_YELLOW);
	}
	 wrefresh(menu);wrefresh(right); 
	 wrefresh(left); wrefresh(bottom);wrefresh(top);
}

void change_shell()
{
  WINDOW *temp,*outer;
	PANEL *ptemp; 
	string file_names;
	temp=newwin(2,28,maxy/2-1,maxx/2-14);
	outer=newwin(4,30,maxy/2-2,maxx/2-15);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0);
	wrefresh(outer);
	mvwprintw(temp,0,3,"TYPE EXIT TO COME BACK");
	wattron(temp,A_REVERSE);
	mvwprintw(temp,1,12,"OK");
	wmove(temp,2,12);
	wattron(temp,A_REVERSE);
	wgetch(temp);
endwin();
scr_dump("temp_shell");
system("clear;/bin/bash");
scr_set("temp_shell");
system("rm -f temp_shell");
}





 int load_a_file(char *file_name,int *lines_p)
{
	wmove(win,topmar,leftmar);
	WINDOW *temp,*outer;
	PANEL *ptemp;
	temp=newwin(2,28,maxy/2-1,maxx/2-14);
	outer=newwin(4,30,maxy/2-2,maxx/2-15);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0);
	wrefresh(outer);
	mvwprintw(temp,0,5,"ENTER THE FILENAME");
	wmove(temp,1,3);
	wrefresh(temp);
	keypad(temp,TRUE);
	chtype c;int count=0;
		c=wgetch(temp);
		while(c!='\n')
		{
			if(c==KEY_BACKSPACE)
			{
				if(count>0)
				{
					file_name[count]='\0';
					file_name[count-1]=' ';
					wmove(temp,1,3);
					waddstr(temp,file_name);
					file_name[--count]='\0';
				        wmove(temp,1,3+strlen(file_name));	
				}
			}
				else
				{
					file_name[count++]=c;
					waddch(temp,c);
				}
				wrefresh(temp);
				c=wgetch(temp);
		}
	file_name[count]='\0';
	clean_up();
	int load_err=load_file(file_name,lines_p);
	if(load_err!=0)
	{        wattron(temp,A_BLINK);
		mvwprintw(temp,1,0,"       NO such file         ");
		wrefresh(temp);
		chtype ca=wgetch(temp);
		return -1;
	}
	mvwprintw(top,0,1," file: %s                    ",file_name);
        wrefresh(top);	
	return 0;
}
void save_as(char *file_name)
{
	wmove(win,topmar,leftmar);
	WINDOW *temp,*outer;
	PANEL *ptemp;
	temp=newwin(2,28,maxy/2-1,maxx/2-14);
	outer=newwin(4,30,maxy/2-2,maxx/2-15);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0);
	wrefresh(outer);
	mvwprintw(temp,0,5,"ENTER THE FILENAME");
	wmove(temp,1,3);
	wrefresh(temp);
	keypad(temp,TRUE);
	chtype c;int count=0;
		c=wgetch(temp);
		while(c!='\n')
		{
			if(c==KEY_BACKSPACE)
			{
				if(count>0)
				{
					file_name[count]='\0';
					file_name[count-1]=' ';
					wmove(temp,1,3);
					waddstr(temp,file_name);
					file_name[--count]='\0';
				        wmove(temp,1,3+strlen(file_name));	
				}
			}
				else
				{
					file_name[count++]=c;
					waddch(temp,c);
				}
				wrefresh(temp);
				c=wgetch(temp);
		}
	file_name[count]='\0';
		top_panel(pan);
		doupdate();
}

void disp_word_error()
{
	WINDOW *temp;
	WINDOW *outer;
	PANEL *pan;
	temp=newwin(4,52,maxy/2-2,maxx/2-26);
	outer=newwin(6,54,maxy/2-3,maxx/2-27);
	wbkgd(temp,COLOR_PAIR(1));
	wbkgd(outer,COLOR_PAIR(3));
	wattron(temp,A_BOLD);
	pan=new_panel(win);
	box(outer,0,0);
	wrefresh(outer);
	beep(); 
	for(int i=0;i<=3000;i++)
		for(int j=0;j<=3000;j++);
	beep();
          char *a=" Did you know that the longest word in english is ";
          char *b=" \"pneumonoultramicroscopicsilicovolcanoconiosis\"? ";
	  char *d="             It has 45 charcacters!!              ";
	  char *e="I hope you'll kindly enter a legal word next time!"; 
	  wmove(temp,0,1);
	  for(int i=0;i<strlen(a);i++)
		    waddch(temp,a[i]);
	  wmove(temp,1,1);
	  for(int i=0;i<strlen(b);i++)
		  waddch(temp,b[i]);
	  wmove(temp,2,1);
	  for(int i=0;i<strlen(d);i++)
		  waddch(temp,d[i]);
	  wmove(temp,3,1);
	  for(int i=0;i<strlen(d);i++)
		  waddch(temp,e[i]);
	  wrefresh(temp);
	  flushinp();
	  wgetch(temp);
	  top_panel(pan);
	  doupdate();

}

void disp_search_not()
{
	WINDOW *temp;
	WINDOW *outer;
	PANEL *pan;
	wrefresh(win);
	temp=newwin(2,24,maxy/2-1,maxx/2-12);
	outer=newwin(4,26,maxy/2-2,maxx/2-13);
	wbkgd(temp,COLOR_PAIR(1));
	wbkgd(outer,COLOR_PAIR(3));
	wattron(temp,A_BOLD);
	pan=new_panel(win);
	box(outer,0,0);
	wrefresh(outer);
          char *a="Search not successfull";
          char *b="          OK           ";
	  wmove(temp,0,1);
	  for(int i=0;i<strlen(a);i++)
		    waddch(temp,a[i]);
	  wmove(temp,1,1);
	  for(int i=0;i<strlen(b);i++)
		  waddch(temp,b[i]);
	  wrefresh(temp);
	  flushinp();
	  wgetch(temp);
	  top_panel(pan);
	  doupdate();

}

void disp_searchcount(int num)
{
	WINDOW *temp;
	WINDOW *outer;
	PANEL *pan;
	wrefresh(win);
	temp=newwin(2,28,maxy/2-1,maxx/2-14);
	outer=newwin(4,30,maxy/2-2,maxx/2-15);
	wbkgd(temp,COLOR_PAIR(1));
	wbkgd(outer,COLOR_PAIR(3));
	wattron(temp,A_BOLD);
	pan=new_panel(win);
	box(outer,0,0);
	wrefresh(win);
	wrefresh(outer);
	mvwprintw(temp,0,5,"NO. OF REPLACES %d",num);
	mvwprintw(temp,1,12,"OK?");
	  wrefresh(temp);
	  flushinp();
	  wgetch(temp);
	  top_panel(pan);
	  doupdate();

}


int disp_s_fromup()
{
		WINDOW *temp;
		WINDOW *outer;
		PANEL *ptemp;
		temp=newwin(2,36,maxy/2-1,maxx/2-18);
		outer=newwin(4,38,maxy/2-2,maxx/2-19);
		ptemp=new_panel(temp);
		top_panel(ptemp);
		doupdate();
		wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
		wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
		box(outer,0,0); 
		wrefresh(outer);
		mvwprintw(temp,0,1,"Search hit BOTTOM, continue at TOP ");
		mvwprintw(temp,1,16,"Y\\N?");
		wrefresh(temp);
               chtype c=wgetch(temp);
               if(c=='y'||c=='Y')
                  return 1;
                else if(c=='n'||c=='N')
                  return 0;
}


int get_word(char *word,char *a) {
	WINDOW *temp; 
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(2,48,maxy/2-1,maxx/2-24);
	outer=newwin(4,50,maxy/2-2,maxx/2-25);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0); 
	wrefresh(outer);
        	
	mvwprintw(temp,0,15,a);
	wmove(temp,1,1);
	wrefresh(temp);
	keypad(temp,TRUE);
	chtype c;int count=0;
		c=wgetch(temp);
		while(c!='\n')
		{
		if(c==KEY_BACKSPACE)
		{
		 if(count>0)
		  {
		   word[count-1]=' ';
		   word[count]='\0';
		   wmove(temp,1,1);
		   waddstr(temp,word);
		   word[--count]='\0';
		   wmove(temp,1,1+strlen(word));
		  }
		}										else
		 {
		  if (c==' '||c=='\t')    break;
		  word[count++]=c;
		  if (count==46) {
		top_panel(pan);
		doupdate();
			  disp_word_error();
			  return -1;
		  }
		  waddch(temp,c);
		 }
		wrefresh(temp);
		c=wgetch(temp);
		}
		word[count]='\0';
		top_panel(pan);
		doupdate();
		return strlen(word);
}	




int get_lineno(int lines)
{

	wmove(win,topmar,leftmar);
	WINDOW *temp;
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(2,30,maxy/2-1,maxx/2-15);
	outer=newwin(4,32,maxy/2-2,maxx/2-16);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0); 
	wrefresh(outer);
	mvwprintw(temp,0,4," Enter the line number ");
	wmove(temp,1,15);
	echo();
	wrefresh(temp);
	keypad(temp,TRUE);
	int num;
	mvwscanw(temp,1,13,"%d",&num);
	if (num<1 || num >lines) {
		wattron(temp,A_BLINK);
		mvwprintw(temp,1,4," Invalid line number   ");
		noecho();
		wrefresh(temp);
		chtype c=wgetch(temp);
		return -1;
	}
	noecho();
		top_panel(pan);
		doupdate();
        return num;
}	

int get_no_of_lines()
{

	wmove(win,topmar,leftmar);
	WINDOW *temp;
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(2,30,maxy/2-1,maxx/2-15);
	outer=newwin(4,32,maxy/2-2,maxx/2-16);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0);
       	wrefresh(outer);
	mvwprintw(temp,0,4," Enter the no. of lines ");
	wmove(temp,1,15);
	echo();
	wrefresh(temp);
	keypad(temp,TRUE);
	int num;
	mvwscanw(temp,1,13,"%d",&num);
	if (num<0)  { noecho(); return -1; }
	noecho();
		top_panel(pan);
		doupdate();
        return num;
}	
	
int get_topbot()
{
	wmove(win,topmar,leftmar);
	WINDOW *temp;
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(2,34,maxy/2-1,maxx/2-17);
	outer=newwin(4,36,maxy/2-2,maxx/2-18);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0); 
	wrefresh(outer);
	mvwprintw(temp,0,4,"   Enter the top margin   ");
	wmove(temp,1,15);
	echo();
	wrefresh(temp);
	keypad(temp,TRUE);
	int num;
	mvwscanw(temp,1,16,"%d",&num);
	if (num<0 || num >=maxy-1) {
		wattron(temp,A_BLINK);
		mvwprintw(temp,1,4,"    Invalid top margin      ");
		noecho();
		wrefresh(temp);
		chtype c=wgetch(temp);
		return -1;
	}
	mvwprintw(temp,0,4,"  Enter the bottom margin  ");
	mvwprintw(temp,1,0,"                        ");
	wmove(temp,1,15);
	wrefresh(temp);
	keypad(temp,TRUE);
	int num2;
	mvwscanw(temp,1,16,"%d",&num2);
	if (num2<1 || num2 >maxy-1 || num2<=num) {
		wattron(temp,A_BLINK);
		mvwprintw(temp,1,4,"   Invalid bottom margin      ");
		noecho();
		wrefresh(temp);
		chtype c=wgetch(temp);
		return -1;
	}
        MAX_LINES=num2;
        topmar=num;
	noecho();
		top_panel(pan);
		doupdate();
        return num;
}
int get_leftright()
{
	wmove(win,topmar,leftmar);
	WINDOW *temp;
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(2,34,maxy/2-1,maxx/2-17);
	outer=newwin(4,36,maxy/2-2,maxx/2-18);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
	box(outer,0,0); 
	wrefresh(outer);
	mvwprintw(temp,0,4,"   Enter the left margin   ");
	wmove(temp,1,15);
	echo();
	wrefresh(temp);
	keypad(temp,TRUE);
	int num;
	mvwscanw(temp,1,16,"%d",&num);
	if (num<0 || num >maxx-3) {
		wattron(temp,A_BLINK);
		mvwprintw(temp,1,4,"    Invalid left margin      ");
		noecho();
		wrefresh(temp);
		chtype c=wgetch(temp);
		return -1;
	}
	mvwprintw(temp,0,4,"  Enter the right margin  ");
	mvwprintw(temp,1,0,"                        ");
	wmove(temp,1,15);
	wrefresh(temp);
	keypad(temp,TRUE);
	int num2;
	mvwscanw(temp,1,16,"%d",&num2);
	if (num2<1 || num2 >=LINE_LENGTH || num2<=num) {
		wattron(temp,A_BLINK);
		mvwprintw(temp,1,4,"   Invalid right margin      ");
		noecho();
		wrefresh(temp);
		chtype c=wgetch(temp);
		return -1;
	}
        rightmar=num2;
        leftmar=num;
	noecho();
		top_panel(pan);
		doupdate();
        return num;
}	


void new_file()
{
	clean_up();
	wmove(win,topmar,leftmar);
	wrefresh(win);
	doupdate();
}

int repl_all_single()
{
		WINDOW *temp;
		WINDOW *outer;
		temp=newwin(2,28,maxy/2-1,maxx/2-14);
		outer=newwin(4,30,maxy/2-2,maxx/2-15);
		wrefresh(win);
		wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
		wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
		box(outer,0,0);
	       	wrefresh(outer); 
		mvwprintw(temp,0,3,"REPLACE ALL OR SINGLE");
		mvwprintw(temp,1,2,"a FOR ALL, s for SINGLE?");
		wrefresh(temp);
               chtype c=wgetch(temp);
               if(c=='a'||c=='A')
                  return 2;
                else if(c=='s'||c=='S')
                  return 1;
	       else return 0;
}

int exit_editor()
{
		WINDOW *temp;
		WINDOW *outer;
		PANEL *ptemp;
		temp=newwin(2,28,maxy/2-1,maxx/2-14);
		outer=newwin(4,30,maxy/2-2,maxx/2-15);
		ptemp=new_panel(temp);
		top_panel(ptemp);
		doupdate();
		wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
		wbkgd(outer,COLOR_PAIR(3)|A_BOLD);
		box(outer,0,0);
	       	wrefresh(outer);
		mvwprintw(temp,0,5,"EXIT WITHOUT SAVING");
		mvwprintw(temp,1,12,"Y\\N?");

		wrefresh(temp);
               chtype c=wgetch(temp);
               if(c=='y'||c=='Y')
                  return 1;
                else if(c=='n'||c=='N')
                  return 0;
}


void about_window()
{
	WINDOW *temp;
	WINDOW *outer;
	PANEL *pan;
	temp=newwin(8,40,maxy/2-4,maxx/2-20);
	outer=newwin(10,42,maxy/2-5,maxx/2-21);
	wbkgd(temp,COLOR_PAIR(1));
	wbkgd(outer,COLOR_PAIR(3));
	wattron(temp,A_BOLD);
	pan=new_panel(win);
	box(outer,0,0);
	wrefresh(outer);
	wrefresh(win);
          char *a="Anj edit for Linux  VERSION 0.5";
	  char *b=" Copyright 2000  MANJUNATH C.L ";
	  char *d="E-mail:  mania_en@rediffmail.com"; 
	  wmove(temp,2,4);
	  for(int i=0;i<strlen(a);i++)
	  {
		    waddch(temp,a[i]);
		    if (a[i]==' ') {
			    for (int k=0; k<6500; k++) wrefresh(temp);
		    }
	  }
	  wmove(temp,3,4);
	  for(int i=0;i<strlen(b);i++)
	  {
		  waddch(temp,b[i]);
		    if (b[i]==' ') {
			    for (int k=0; k<6500; k++) wrefresh(temp);
		    }
	  }
	  wmove(temp,5,4);
	  for(int i=0;i<strlen(d);i++)
	  {
		  waddch(temp,d[i]);
		    if (d[i]==' ') {
			    for (int k=0; k<6500; k++) wrefresh(temp);
		    }
	  }
	  int j=0,i;
	  while (j<5) {
	        wbkgd(temp,COLOR_PAIR(2));
	        wattron(temp,A_BOLD);
	  for (i=0; i<=10100; i++) wrefresh(temp);
	  wmove(temp,2,4);
	  for(i=0;i<strlen(a);i++)
		    waddch(temp,a[i]);
	  wmove(temp,3,4);
	  for(i=0;i<strlen(b);i++)
		  waddch(temp,b[i]);
	  wmove(temp,5,4);
	  for( i=0;i<strlen(d);i++)
		  waddch(temp,d[i]);
	  wrefresh(temp);
	  for (i=0; i<=10100; i++) wrefresh(temp);
	        wbkgd(temp,COLOR_PAIR(1));
	        wattron(temp,A_BOLD);
	  wmove(temp,2,4);
	  for(i=0;i<strlen(a);i++)
		    waddch(temp,a[i]);
	  wmove(temp,3,4);
	  for(i=0;i<strlen(b);i++)
		  waddch(temp,b[i]);
	  wmove(temp,5,4);
	  for(i=0;i<strlen(d);i++)
		  waddch(temp,d[i]);
	  wrefresh(temp);
	  j++;
	  }
	  flushinp();
	  wgetch(temp);
	  top_panel(pan);
	  doupdate();

}
