#include"dimens.h"
#include<iostream.h>
#include"common.h"
#include"defs.h"
#include<stdlib.h>
#include"bar_and_menu.h"
#include<curses.h>
#include<string.h>
#include<unistd.h>
#define RC d.show_rc(statbar);

int kireek= 0;

bool named= 0, saved= 0;
bool statbar_active= false;
WINDOW *titlebar, *menubar, *textwin, *text, *statbar;
Data_structure d;
int L_m= 0, R_m= 0, T_m= 0, B_m= 0;
int WID= 78 - L_m - R_m, HGT= 20 - T_m - B_m, TAB= 5;
char curr_file_name[100];
int colors[4][2];
int menu_color_pair= 1, textwin_color_pair= 2, statusbar_color_pair= 3;

bool is_file_there(char*, int);

int main(int argc, char *argv[])
{
  strcpy(curr_file_name, "Not_yet_named");
  int y= 0, x= 0;
  bool flag= 0;
  chtype ch;
  int choice;
  start_curses();
  dra_menubar();
  dra_statbar();
  dra_titlebar();
  dra_textwin();
  int num= argc;
  while(--num)  {
    if(argv[num][0] == '-')
      switch(argv[num][1])  {
	case 'r' :
		  d.set_readonly();
		  break;
	default  :
		  endwin();
		  cout<< "Unknown option --"<< argv[num][1]<< endl;
		  beep();
		  exit(0);
      }
  }
  num= 1;
  while(num < argc)  { 
     if(argv[num][0] != '-')  {
        if(is_file_there(argv[num], 2)){
           d.load(argv[num]);
 	   strcpy(curr_file_name, argv[num]);
 	   named= 1;
 	   saved= 1;
 	   break;
 	}
 	else  {
           if((d.is_readonly() && access(argv[num], R_OK))  || 
           		(!d.is_readonly() && access(argv[num], W_OK)))  {
	      endwin();
 	      cout<<"Permission denied\n";
 	      beep();
 	      exit(0);
 	   }
 	   strcpy(curr_file_name, argv[num]);
 	   named= 1;
 	   saved= 1;
 	   break;
 	}
     }
     num++;
  }
  d.show_rc(statbar);
  d.showtext_scr(text);
  d.show_cursor(text);
  wrefresh(textwin);
//HERE ENDS       
  while(1)   {
    addto_title_bar();
    d.show_rc(statbar);
//    d.show_tb(statbar);
    mvwprintw(statbar, 0, 15, "%3d%%", d.percentage());
    if(!statbar_active)  {
       wclrtoeol(statbar);
       mvwprintw(statbar, 0, 55, "LONG     LIVE    LINUX");
    }
    else
       statbar_active= false;
    wrefresh(statbar);
    d.showtext_scr(text);
    d.show_cursor(text);
    wrefresh(textwin) ;
    ch = wgetch(text);
    do  {
      flag= 0;
      switch(ch)    { 
    	  case ESC	 :
    			  beep();
			  break;		 
	  case KEY_F(1)	 :
			  process(5, 3);
			  wrefresh(menubar);
			  break;
	  case KEY_F(2)	 :
			  process(4, 1);
			  wrefresh(menubar);
			  break;
	  case KEY_F(3)	 :
			  process(nnos ,2);
			  nnos= 8;
			  break;
          case CTRL('x') :
                          endwin();
			  process(6, 1);
			  break;
          case CTRL('w') :
  		 	  activatetab(1,menubar);
 		 	  choice= showmenu(workmenu,wnos,1);
			  touchwin(textwin);
			  wrefresh(textwin);
			  if(choice > 0)   process(choice,1);
			  else if(choice < 0) {
		            ch= changeto(choice);
			    flag++;
			   }
			  deactivatetab(1,menubar);
                          break;
          case CTRL('n') :
			  activatetab(2,menubar);
                          choice= showmenu(needsmenu,nnos,2);
                          touchwin(textwin);
			  wrefresh(textwin);
			  if(choice == 7)
				nnos= 8;
			  if(choice > 0)   process(choice,2);
			  else if(choice < 0) {
			    ch= changeto(choice);
			    flag++;
			   }
			  deactivatetab(2,menubar);
			  break;
          case CTRL('t') : 
			  activatetab(3,menubar);
			  choice= showmenu(tkitmenu, tnos, 3);
			  touchwin(textwin);
			  wrefresh(textwin);			  
			  if(choice == 6 || choice == 7)
				tnos= 8;
			  if(choice > 0)   process(choice,3);
			  else if(choice < 0)  {
			    ch= changeto(choice);
			    flag++;
			   }	
			  deactivatetab(3,menubar);
                          break;
          case CTRL('a') :
			  activatetab(4,menubar);
			  choice= showmenu(aboutmenu, anos, 4);
			  touchwin(textwin);
			  wrefresh(textwin);
			  if(choice > 0)   process(choice,4);
			  else if(choice < 0)  {
		            ch= changeto(choice);
			    flag++;
			   }
			  deactivatetab(4,menubar);
			  break;
          case KEY_UP    :  d.process(ch); break ;
          case KEY_DOWN  :  d.process(ch); break ;
          case KEY_LEFT  :  d.process(ch); break ; 
          case KEY_RIGHT :  d.process(ch); break ; 
          default        : /* All other Keys */
			  d.process(ch);
                   	  break;
      }
//      mvwprintw(statbar, 0, 40, "%d,  %d", saved, named);
     }while(flag);
  }
  endwin();
  system("clear");
  return 0;
} 

