#include<iostream.h>
#include<fstream.h>
#include<stdlib.h>
#include<cstdlib>
#include<ctype.h>
#include<string>
#include<vector>
#include<curses.h>
#include<panel.h>
//#include<sys/types.h>
//#include<sys/stat.h>
//#include<unistd.h>
bool INSMODE=1;
int cursmode=1;
#include"macro.cpp"
#include"window.cpp"
#include"datastrc.cpp"    

void main()
{
 int menu_pos=1,select;
 int screen_x=0,screen_y=0,data_x=0,data_y=0;
 chtype ch;   FILE *fptr;
 system("vga=4"); 
 //********* window declerations ***********
 
 window main,menu,status,frame;
 popdown file,edit,opt,help;
 window *temp;

 //**********  datastructure decleration *********
 datastr buff;
 
 //******* initializations **********
 initscr();
 noecho();
 start_color();
 keypad(stdscr,TRUE);
 //****** For main window*******
 init_pair(1,COLOR_WHITE,COLOR_BLUE);

 //****** For pop down menus *******
 init_pair(2,COLOR_BLACK,COLOR_WHITE);
 init_pair(3,COLOR_GREEN,COLOR_WHITE);

 //****** For highlighting in opensave and page setup windwos *******
 init_pair(4,COLOR_WHITE,COLOR_GREEN);

 //****** For message display windwos ******
 init_pair(8,COLOR_WHITE,COLOR_WHITE);  //main window colors
 init_pair(5,COLOR_RED,COLOR_WHITE);  //selection colors

 //********* screen initializations ************
 main.create(21,78,1,2,1);
 wattron(main.ptr(),A_BOLD);
 frame.create(23,80,0,1,1);
 wattron(frame.ptr(),A_BOLD);
 frame.wbox();
 menu.create(1,80,0,0,2);
 menu.addchar(0,0,"  File      Edit      Options      Help");
 status.create(1,80,0,24,2);
 string s[]={"New","Open          F3","Save","Save as","Close","Delete","Exit       ALT+x"};
 file.create(9,18,2,1,s,1);
 string s2[]={"Cut           F5","Copy          F6","Paste         F7","Delete        F8","Del word      ^w","Del line      ^l","Shell"};
 edit.create(9,18,12,1,s2,2);
 string s3[]={"Page setup","Preferences"};
 opt.create(4,20,22,1,s3,3);
 string s4[]={"Commands","About"};
 help.create(4,18,35,1,s4,4);
 menu.display();
 main.display();
 status.display();
 REFRESH;
 curs_set(cursmode);
 keypad(main.ptr(),TRUE);
 
 //**************  main editor loop  ***********
 ungetch('\n');
 ungetch('f');
 ungetch(27);
 while(1)
 {
  switch(ch=wgetch(main.ptr()))
  {
   case 27: curs_set(0);
	    //nodelay(main.ptr());
	    ch=getch();
	    //buff.writetobar(status,"F-file E-edit");
	    if(ch=='f') { temp=&file; menu_pos=1; }
	    else if(ch=='e') { temp = &edit; menu_pos=2; }
	    else if(ch=='o') { temp = &opt; menu_pos=3; } 
	    else if(ch=='h') { temp = &help; menu_pos=4; }
	    else if( ch=='x')  {  
			if(buff.closefile(0)) {
				endwin();  
				system("clear"); 
				exit(0);  
			}
			ungetch(27);
	    }		
	    else ch='\n';
	    temp->display();
            while(ch!='\n'&& ch!=27) {
	    switch(ch=getch())
	    {
	     case KEY_DOWN:temp->down();
	                   break;
	     case KEY_UP:temp->up();
	                 break;
	     case KEY_LEFT:if(menu_pos==1)  {  temp=&help; menu_pos=5; }
                           else if(menu_pos==2) temp=&file;
                           else if(menu_pos==3) temp=&edit;
                           else if(menu_pos==4) temp=&opt;
                           menu_pos--;
                           break;
             case KEY_RIGHT:if(menu_pos==1)  temp=&edit; 
                            else if(menu_pos==2) temp=&opt;
                            else if(menu_pos==3) temp=&help;
                            else if(menu_pos==4) { temp=&file; menu_pos=0; }
                            menu_pos++;
                            break;
             case '\n'://************  select a menu **********
		       temp->hide();
		       select=temp->detect();
                       switch(select)
                       {
			case 1:buff.newfile();
			       buff.scrref(main.ptr());
			       UPDATE;
			       break;
			case 2:
			       buff.open();
			       buff.scrref(main.ptr());
			       UPDATE;
			       break;
                        case 3:buff.save();
			       buff.scrref(main.ptr());
			       UPDATE;
			       break;
			case 4:buff.saveas();
			       buff.scrref(main.ptr());
			       UPDATE;
			       break;
			case 5:if(buff.closefile(1)) {
				buff.newfile();
				buff.scrref(main.ptr());
				UPDATE;
			       }	
			       break;
			case 6:buff.delfile();
			       buff.scrref(main.ptr());
			       UPDATE;
			       break;
			case 7:if(buff.closefile(0)) {
			       	endwin();
                               	system("clear");
                               	exit(0); 
			       }
			       break;
			case 8:buff.cut();
			       buff.scrref(main.ptr());
			       UPDATE;
			       break;
			case 9:buff.copy();
			       buff.scrref(main.ptr());
			       UPDATE;
			       break;
			case 10:buff.paste();
			        buff.scrref(main.ptr());
				UPDATE;
				break;
			case 11:buff.delsel();
			        buff.scrref(main.ptr());
				UPDATE;
				break;
			case 12:buff.delword();
			        buff.scrref(main.ptr());
			        UPDATE;
			        break;
			case 13:buff.delline();
			        buff.scrref(main.ptr());
			        UPDATE;
			        break;
			case 14:buff.callshell();
				break;
			case 15:buff.writetobar(status,"Pageup Pagedown to select UP & DOWN to change value");
				buff.pagesetup();
			        main.display();
			        buff.scrref(main.ptr());
			        UPDATE;		
			        break;
                        case 16:buff.writetobar(status,"Tab- Switch b'n options Up & Down to select value");
				buff.select_color(main);
                                buff.scrref(main.ptr());
				UPDATE;
				break; 
			case 17:buff.help();
				break;
			case 18:buff.about();
				break;
                       }
		       temp=&main;
                       break; 
             case 27:temp=&main;
	     	     break;	
	     default: 
	              break;
            }  
            REFRESH;
            main.display();
	    temp->display();
	   }
	   curs_set(cursmode); 
	   break;
   case KEY_UP:
	       if(buff.keyup()==1)
		       buff.scrref(main.ptr());
	       UPDATE;
	       break;
   case KEY_DOWN:
	         if(buff.keydown()==1)
			 buff.scrref(main.ptr());
		 UPDATE;
	         break;
   case KEY_LEFT:if(buff.keyleft()==1)
			 buff.scrref(main.ptr());
		 UPDATE;
                 break;
   case KEY_RIGHT:if(buff.keyright()==1)
			  buff.scrref(main.ptr());
		  UPDATE;
                  break;
   case KEY_DC:if(buff.delchar()==1) {
			buff.scrref(main.ptr());
		 	UPDATE;
		}
		 break;
   case KEY_IC:if(INSMODE==0) { INSMODE=1; cursmode=1; }
               else  {  INSMODE=0;  cursmode=2;  }
	       curs_set(cursmode);	
	       UPDATE;
	       break;
   case KEY_BACKSPACE:if(buff.backspace()) {
			  buff.scrref(main.ptr());
			  UPDATE;
		 	}
		 	break;
   case KEY_HOME:if(buff.home()) {
			buff.scrref(main.ptr());
			UPDATE;
		 }
		 break;
   case 360://Scans the key END
   		if(buff.end()) {
   			buff.scrref(main.ptr());
			UPDATE;
		}
		break;
   case KEY_PPAGE:buff.pageup();
   		   buff.scrref(main.ptr());
		   UPDATE;
		   break;
   case KEY_NPAGE:buff.pagedown();
   		     buff.scrref(main.ptr());
		     UPDATE;
		     break;
   case 23://CTRL+w   *****delete a word****
   	   buff.delword();
   	   buff.scrref(main.ptr());
	   UPDATE;
   	   break;
   case 12://CTRL+l  ******delete a line****
   	   buff.delline();
	   buff.scrref(main.ptr());
	   UPDATE;
	   break;
   case 1:buff.start_copy();
          break;
   case 2:buff.end_copy();
          break;
   case KEY_F(5):buff.cut();
                 buff.scrref(main.ptr());
		 UPDATE;
		 break;
  case KEY_F(6):buff.copy();
                buff.scrref(main.ptr());
                UPDATE;
                break;
  case KEY_F(7):buff.paste();
                buff.scrref(main.ptr());
                UPDATE;
                break; 
  case KEY_F(8):buff.delsel();
                buff.scrref(main.ptr());
                UPDATE;
                break;
  case KEY_F(3):curs_set(0);
		 buff.open();
		 buff.scrref(main.ptr());
		 UPDATE;
		 curs_set(cursmode);
		 break;
   case KEY_F(1):buff.help();
                 break;
   case KEY_F(2):buff.save();
                 buff.scrref(main.ptr());
                 UPDATE;
                 break;
   case '\n':
	     if(buff.enter()==1) {
		buff.scrref(main.ptr());
	        UPDATE;
	     }
	     break;
   default:if(!(isprint(ch)||isspace(ch)))
	   	break;
	   if(INSMODE==1)
	   	buff.ins(ch);
	   else 
	        buff.replace(ch);
  	   buff.scrref(main.ptr());
           UPDATE;
	   break;
	 
  }
 }
 endwin();
} 
