#define LINE_LENGTH 255		
#define TAB_SPACING 5		
int MAX_COLS=64;
int LOH=4;
int TOP_VAL=1;
int MAX_LINES=19;

struct line
  {				
    char *content;
    int number;
    struct line *next;
  };

struct yank {
	char content[LINE_LENGTH];
};
int yank_count=0;
yank yanknode; 
list<yank> Y;
int yankflag=0;

typedef struct line rad;
char *filemenu[]={" NEW          "," OPEN         "," SAVE         "," SAVE AS      "," DELETE       "," EXIT         "};
 char *delmenu[]={" WORD         "," LINE         "," EOL          "};
 char *editmenu[]={" RIGHT COL    "," LEFT COL     "," TOP LINE     "," BOT LINE     "," DEFAULT      "};
  char *docmenu[]={" NEXT COLOR   "," SHELL        "," RELAX        "," GOTO LINE    "};
   char *helpmenu[]={" CONTENTS     "," ABOUT        "};
char *insertmenu[]={" WORD         "," LINE ABOVE   "," LINE BELOW   "};
 char *yankmenu[]={" CUT          "," COPY         "," PASTE        "};
   char *main_msg="Press <CLRT> and [F,N,D,V,E,O,H]   for options         ";
char *searchmenu[]={" FIND         "," FIND AGAIN   "," FIND REPLACE "};

   
static void finish ();
void clean_up (void);
void push_numbers (int line_number);
void add_line (char *buffer, int line_number);
void modify_line (char *buffer, int line_number);
void del_line (int line_number);
char *get_line (int line_number);
void show_list (int top_line, int MIN_COLS, int y, int x);
int save_file (char *file_name);
int load_file (char *file_name, int *lines);
rad *head = NULL;		/* The head pointer for the linked list. */
WINDOW *win,*side,*bottom;
PANEL *pan,*pside,*pbottom;

int repl_all_single()
{
	
	WINDOW *temp;
		WINDOW *outer;
		temp=newwin(2,28,10,20);
		outer=newwin(4,30,9,19);
		wrefresh(win);
		wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
		wbkgd(outer,COLOR_PAIR(1)|A_BOLD);
		box(outer,0,0);
	       	wrefresh(outer);
		mvwprintw(temp,0,3,"REPLACE ALL OR SINGLE");
		mvwprintw(temp,1,2,"a FOR ALL, s for SINGLE?");
		wrefresh(temp);
               chtype c=wgetch(temp);
               if(c=='a'||c=='A')
                  return 2;
                else if(c=='s'||c=='S')
                  return 1;
	       else return 0;
}

void disp_word_error()
{
	WINDOW *temp;
	WINDOW *outer;
	PANEL *pan;
	temp=newwin(4,52,10,3);
	outer=newwin(6,54,9,2);
	wbkgd(temp,COLOR_PAIR(1));
	wbkgd(outer,COLOR_PAIR(1));
	wattron(temp,A_BOLD);
	pan=new_panel(win);
	box(outer,0,0);
	wrefresh(outer);
	beep();
	for(int i=0;i<=3000;i++)
		
	for(int j=0;j<=3000;j++);
	beep();

		
          char *a=" Did you know that the longest word in english is ";
          char *b=" \"pneumonoultramicroscopicsilicovolcanoconiosis\"? ";
	  char *d="             It has 45 charcacters!!              ";
	  char *e="I hope you'll kindly enter a legal word next time!";
	  wmove(temp,0,1);
	  for(int i=0;i<strlen(a);i++)
		    waddch(temp,a[i]);
	  wmove(temp,1,1);
	  for(int i=0;i<strlen(b);i++)
		  waddch(temp,b[i]);
	  wmove(temp,2,1);
	  for(int i=0;i<strlen(d);i++)
		  waddch(temp,d[i]);
	  wmove(temp,3,1);
	  for(int i=0;i<strlen(d);i++)
		  waddch(temp,e[i]);
	  wrefresh(temp);
	  flushinp();
	  wgetch(temp);
	  top_panel(pan);
	  doupdate();

}

void disp_search_not()
{
	WINDOW *temp;
	WINDOW *outer;
	PANEL *pan;
	wrefresh(win);
	temp=newwin(2,24,10,20);
	outer=newwin(4,26,9,19);
	wbkgd(temp,COLOR_PAIR(1));
	wbkgd(outer,COLOR_PAIR(1));
	wattron(temp,A_BOLD);
	pan=new_panel(win);
	box(outer,0,0);
	wrefresh(outer);
          char *a="Search not successfull";
          char *b="          OK           ";
	  wmove(temp,0,1);
	  for(int i=0;i<strlen(a);i++)
		    waddch(temp,a[i]);
	  wmove(temp,1,1);
	  for(int i=0;i<strlen(b);i++)
		  waddch(temp,b[i]);
	  wrefresh(temp);
	  flushinp();
	  wgetch(temp);
	  top_panel(pan);
	  doupdate();

}

void disp_searchcount(int num)
{
	WINDOW *temp;
	WINDOW *outer;
	PANEL *pan;
	wrefresh(win);
	temp=newwin(2,28,10,20);
	outer=newwin(4,30,9,19);
	wbkgd(temp,COLOR_PAIR(1));
	wbkgd(outer,COLOR_PAIR(1));
	wattron(temp,A_BOLD);
	pan=new_panel(win);
	box(outer,0,0);
	wrefresh(win);
	wrefresh(outer);
	mvwprintw(temp,0,5,"NO. OF REPLACES %d",num);
	mvwprintw(temp,1,12,"OK?");
	  wrefresh(temp);
	  flushinp();
	  wgetch(temp);
	  top_panel(pan);
	  doupdate();

}


int disp_s_fromup()
{
		WINDOW *temp;
		WINDOW *outer;
		PANEL *ptemp;
		temp=newwin(2,36,10,20);
		outer=newwin(4,38,9,19);
		ptemp=new_panel(temp);
		top_panel(ptemp);
		doupdate();
		wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
		wbkgd(outer,COLOR_PAIR(1)|A_BOLD);
		box(outer,0,0);
		wrefresh(outer);
		mvwprintw(temp,0,1,"Search hit BOTTOM, continue at TOP ");
		mvwprintw(temp,1,16,"Y\\N?");
		wrefresh(temp);
               chtype c=wgetch(temp);
               if(c=='y'||c=='Y')
                  return 1;
                else if(c=='n'||c=='N')
                  return 0;
}


int get_word(char *word,char *a) {
	WINDOW *temp;
	WINDOW *outer;
	PANEL *ptemp;
	temp=newwin(2,48,10,20);
	outer=newwin(4,50,9,19);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	wbkgd(outer,COLOR_PAIR(1)|A_BOLD);
	box(outer,0,0);
	wrefresh(outer);
        	
	mvwprintw(temp,0,15,a);
	wmove(temp,1,1);
	wrefresh(temp);
	keypad(temp,TRUE);
	chtype c;int count=0;
		c=wgetch(temp);
		while(c!='\n')
		{
		if(c==KEY_BACKSPACE)
		{
		 if(count>0)
		  {
		   word[count-1]=' ';
		   word[count]='\0';
		   wmove(temp,1,1);
		   waddstr(temp,word);
		   word[--count]='\0';
		   wmove(temp,1,1+strlen(word));
		  }
		}										else
		 {
		  if (c==' '||c=='\t')    break;
		  word[count++]=c;
		  if (count==46) {
		top_panel(pan);
		doupdate();
			  disp_word_error();
			  return -1;
		  }
		  waddch(temp,c);
		 }
		wrefresh(temp);
		c=wgetch(temp);
		}
		word[count]='\0';
		top_panel(pan);
		doupdate();
		return strlen(word);
}	




int get_no_of_lines()
{
       wrefresh(win);
       doupdate();
	WINDOW *temp;
	PANEL *ptemp;
	temp=newwin(4,30,10,30);
	ptemp=new_panel(temp);
	top_panel(ptemp);
	doupdate();
	wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
	box(temp,0,0);
	mvwprintw(temp,1,4," Enter the no. of lines ");
	wmove(temp,2,15);
	echo();
	wrefresh(temp);
	keypad(temp,TRUE);
	int num;
	mvwscanw(temp,2,13,"%d",&num);
	if (num<0) return -1;
	noecho();
		top_panel(pan);
		doupdate();
        return num;
}	



void draw()
{
	bottom=newwin(3,80,22,0);
	
	pbottom=new_panel(bottom);
        wbkgd(bottom,COLOR_PAIR(1)|A_BOLD);
	box(bottom,0,0);
	wmove(bottom,1,5);
	waddstr(bottom,main_msg);
	wrefresh(bottom);
	
	side=newwin(22,10,0,70);
        pside=new_panel(side);
        wbkgd(side,COLOR_PAIR(1));
	wmove(side,2,2);
	waddstr(side,"ILE");
	wmove(side,4,2);
	waddstr(side,"SERT");
	wmove(side,6,2);
	waddstr(side,"ELETE");
	wmove(side,8,2);
	waddstr(side,"I PASTE");
	wmove(side,10,2);
	waddstr(side,"QUATE");
	wmove(side,12,2);
	waddstr(side,"PTIONS");
	wmove(side,14,2);
        waddstr(side,"EARCH");
        wmove(side,16,2);
        waddstr(side,"ELP");
        //wattron(side,COLOR_PAIR(4));
	wattron(side,A_BOLD);
	wmove(side,2,1);
	waddstr(side,"F");
	wmove(side,4,1);
	waddstr(side,"N");
	wmove(side,6,1);
	waddstr(side,"D");
	wmove(side,8,1);
	waddstr(side,"V");
	wmove(side,10,1);
	waddstr(side,"E");
	wmove(side,12,1);
	waddstr(side,"O");
	wmove(side,14,1);
        waddstr(side,"S");

	wmove(side,16,1);
        waddstr(side,"H");
	wattron(side,A_BLINK);
	mvwaddstr(side,20,1,"INS");
	wattroff(side,A_BLINK);
	//wattroff(side,COLOR_PAIR(4));
	wattroff(side,A_BOLD);
	wrefresh(side);
}	 	


int new_f()
{
		
	top_panel(pan);
	wrefresh(win);
	doupdate();
	update_panels();
	wrefresh(win);
       doupdate();
	WINDOW *temp;
		PANEL *ptemp;
		temp=newwin(3,35,10,20);
		ptemp=new_panel(temp);
		top_panel(ptemp);
		doupdate();
		wbkgd(temp,COLOR_PAIR(1)|A_BOLD);
		box(temp,0,0);
		mvwprintw(temp,1,4,"CLEAR BUFFER CONTENTS (Y/N)?");

		wrefresh(temp);
	while(1) {	
               chtype c=wgetch(temp);
               if(c=='y'||c=='Y')
                  return 1;
                else if(c=='n'||c=='N')
                  return 0;
	       else beep();
	}
}


int showmenu(char **menuitems,int n,int menu_num,int &c)
{
	wmove(bottom,1,5);
    waddstr(bottom,"Press  <ESC> to exit the pop up menu                ");
    wrefresh(bottom);
  chtype ch= 'f';  int i=1;
  short select=1;
  WINDOW *temp;
  PANEL *ptemp;
   temp=newwin(n+2,16,((menu_num)*2),53);
   wattron(temp,COLOR_PAIR(1));
   wattron(temp,A_BOLD);
   //ptemp=new_panel(temp);
   //top_panel(ptemp);
   //show_panel(ptemp);
   box(temp,0,0);
   keypad(temp,TRUE);
  curs_set(0);
   //wbkgd(temp,COLOR_PAIR(1));
   for(i=1;i<= n;i++)    {
     if(i==1)
       wattrset(temp,A_REVERSE|A_BOLD);
        mvwaddstr(temp,i,1,menuitems[i-1]);
        wattroff(temp,A_REVERSE|A_BOLD);
     	}

      do
         {
          for(i=1;i<= n;i++)
          {
           if(i==select)
             wattrset(temp,A_REVERSE|A_BOLD);
           mvwaddstr(temp,i,1,menuitems[i-1]);
           wattroff(temp,A_REVERSE|A_BOLD);
          }
           flushinp();
           ch=wgetch(temp);
           switch(ch)
          {
		  case 27 :            top_panel(pan);
			     doupdate();
			        curs_set(1);
                                 return -1;
                       	             break;
              case KEY_UP     :
                                if(select==1) select= n;
                                else select--;    break;
              case KEY_DOWN   :
		       	        if(select==n) select= 1;
                               else select++;    break;
             case 10 : top_panel(pan);
		       curs_set(1);
	                return select;
			break;
             default :
			        beep();   break;
	
            }
          }while(ch!=27);
 curs_set(1);
 }

